<?php

/*
Plugin Name: WP-Plugin-Stats
Plugin URI: http://www.avramovic.info/wordpress-plugins/wp-plugin-stats-wordpress-plugin
Description: Adds an Flash chart and shows stats how many downloads your (or any other) WP plugin had.
Version: 0.1.2
Author: Nemanja Avramović
Author URI: http://www.avramovic.info/
*/

function display_stats($plugin_slug) {     		
	return "<object width='540' height='400'><param name='movie' value='http://wordpress.org/extend/stats/charts.swf?library_path=http://wordpress.org/extend/stats/charts_library&amp;php_source=http://wordpress.org/extend/stats/plugin-xml.php?slug=$plugin_slug'></param><param name='wmode' value='transparent'></param><embed src='http://wordpress.org/extend/stats/charts.swf?library_path=http://wordpress.org/extend/stats/charts_library&amp;php_source=http://wordpress.org/extend/stats/plugin-xml.php?slug=$plugin_slug' type='application/x-shockwave-flash' wmode='transparent' width='540' height='400'></embed></object>";
}

function wpstats_get_data($plugin_slug) {
	$fp = @fopen("http://wordpress.org/extend/plugins/$plugin_slug/stats/",'r');
	if ($fp) {
	
		$html = '';	
		while(!feof($fp)) {
			$html .= fread($fp, 1024);
		}
		
		@fclose($fp);
	
		preg_match_all('/<td>(.*)<\/td>/', $html, $result, PREG_PATTERN_ORDER);
		return $result[0];
		
	}
	else return __('Error getting downloads data');
}

function wpstats_countdl_today($plugin_slug) {
	$data = wpstats_get_data($plugin_slug);
	return $data[0];
}

function wpstats_countdl_yesterday($plugin_slug) {
	$data = wpstats_get_data($plugin_slug);
	return $data[1];
}

function wpstats_countdl_lastweek($plugin_slug) {
	$data = wpstats_get_data($plugin_slug);
	return $data[2];
}

function wpstats_countdl_total($plugin_slug) {
	$data = wpstats_get_data($plugin_slug);
	return $data[3];
}

function wpstats_countdl_all($plugin_slug) {
	$data = wpstats_get_data($plugin_slug);
	$wpstats_textz = "<div class='wpstats_all'>" . get_option(wpstats_template) . "</div>";
	$wpstats_textz = str_replace('%today%', $data[0], $wpstats_textz);
	$wpstats_textz = str_replace('%yesterday%', $data[1], $wpstats_textz);
	$wpstats_textz = str_replace('%lastweek%', $data[2], $wpstats_textz);
	$wpstats_textz = str_replace('%total%', $data[3], $wpstats_textz);
	
	return $wpstats_textz;
}

if (!function_exists('add_filter')) {

include_once('../../../wp-blog-header.php');

	if (isset($_REQUEST['plugin_slug'])) {
		if (isset($_REQUEST['period'])) {
			$period = $_REQUEST['period'];
		}
		else {
			$period = 'total';
		}
		
		$plugin_slug = $_REQUEST['plugin_slug'];
		
		switch($period) {
			case 'today':
				echo wpstats_countdl_today($plugin_slug);
				break;
			case 'yesterday':
				echo wpstats_countdl_yesterday($plugin_slug);
				break;
			case 'lastweek':
				echo wpstats_countdl_lastweek($plugin_slug);
				break;
			case 'total':
				echo wpstats_countdl_total($plugin_slug);
				break;
			case 'all':
				echo wpstats_countdl_all($plugin_slug);
				break;
			default:
				echo wpstats_countdl_total($plugin_slug);
		}
	
	}
	else {
		die(__('You can\'t access this file directly!'));
	}
}
else {
	add_filter('the_content', 'place_stats', '7');
	add_filter('the_excerpt', 'place_stats', '7');
	add_action("wp_head", "wpstats_addcss");
	add_action("wp_head", "wpstats_addjs");
	add_action('admin_menu', 'wpstats_pages');
}

function wpstats_place_ajax($plugin_slug,$period) {
	global $wpstats_path;

	$now = time();
	return stripslashes("<span id='wpstats-$plugin_slug-$period-$now' style='cursor: pointer' onclick='wpstats_ajax(\"wpstats-$plugin_slug-$period-$now\",\"$plugin_slug\",\"$period\");'><img src='". $wpstats_path .'/click.gif'."' border='0' alt='click me to obtain stats' title='click me to obtain stats' /></span> <script type=\"text/javascript\"> window.onload=function(){ wpstats_ajax(\"wpstats-$plugin_slug-$period-$now\",\"$plugin_slug\",\"$period\"); } </script>");
}

function place_stats($content){
	if(!is_feed()) {
		$content = preg_replace("/\[chart=([a-zA-Z0-9_.-]+)\]/ise", "display_stats('\\1')", $content);
		$content = preg_replace("/\[today=([a-zA-Z0-9_.-]+)\]/ise", "wpstats_place_ajax('\\1','today')", $content);
		$content = preg_replace("/\[yesterday=([a-zA-Z0-9_.-]+)\]/ise", "wpstats_place_ajax('\\1','yesterday')", $content);
		$content = preg_replace("/\[lastweek=([a-zA-Z0-9_.-]+)\]/ise", "wpstats_place_ajax('\\1','lastweek')", $content);
		$content = preg_replace("/\[total=([a-zA-Z0-9_.-]+)\]/ise", "wpstats_place_ajax('\\1','total')", $content);
		$content = preg_replace("/\[stats=([a-zA-Z0-9_.-]+)\]/ise", "wpstats_place_ajax('\\1','all')", $content);
	} else {
		$content = preg_replace("/\[chart=([a-zA-Z0-9_.-]+)\]/i", __('Note: There is a Wordpress plugin stats for plugin "\\1" chart embedded within this post, please visit the site to view the chart.', 'wp-plugin-stats'), $content);
		$content = preg_replace("/\[today=([a-zA-Z0-9_.-]+)\]/i", __('X (visit blog to see a number)', 'wp-plugin-stats'), $content);
		$content = preg_replace("/\[yesterday=([a-zA-Z0-9_.-]+)\]/i", __('X (visit blog to see a number)', 'wp-plugin-stats'), $content);
		$content = preg_replace("/\[lastweek=([a-zA-Z0-9_.-]+)\]/i", __('X (visit blog to see a number)', 'wp-plugin-stats'), $content);
		$content = preg_replace("/\[stats=([a-zA-Z0-9_.-]+)\]/i", __('X (visit blog to see a number)', 'wp-plugin-stats'), $content);
	}
    return $content;
}

function wpstats_addcss() {
	global $wpstats_path;
	echo "\n" . '<link rel="stylesheet" href="' . $wpstats_path . '/wp-plugin-stats.css" type="text/css" media="screen" />' . "\n";
}

function wpstats_addjs() {
	global $wpstats_path;
	echo "\n" . '<script type="text/javascript" src="' . $wpstats_path . '/wp-plugin-stats-js.php"> </script>' . "\n";
}

	// detect the plugin path
	$wpstats_path = get_option('siteurl') . '/wp-content/plugins/wp-plugin-stats';
	
	// for version control and installation
	define('WPSTATS_VERSION', '0.1.2');
	
	// try to always get the values from the database
	$wpstats_version = get_option(wpstats_version);
	$wpstats_template = get_option(wpstats_template);

	
	// if the database value returns empty use defaults
	if($wpstats_version != WPSTATS_VERSION) 
	{
		$wpstats_version = WPSTATS_VERSION; update_option('wpstats_version', WPSTATS_VERSION);
		$wpstats_template =  "Today: <strong>%today%</strong><br />\nYesterday: <strong>%yesterday%</strong><br />\nLast week: <strong>%lastweek%</strong><br />\nTotal: <strong>%total%</strong>"; update_option('wpstats_template', $wpstats_template);
		
	}
	
	function wpstats_pages() {
	    add_options_page('WP Plugin Stats Options', 'Plugin Stats', 5, 'wpstatsoptions', 'wpstats_options');
	}
	
	//print options page
	function wpstats_options() 
	{
     	global $wpstats_path, $wpstats_version, $wpstats_template;
 
     	// if settings are updated
		if(isset($_POST['update_wpstats'])) 
		{
			if(isset($_POST['wpstats_template'])) {
				update_option('wpstats_template', $_POST['wpstats_template']);
				$wpstats_template = $_POST['wpstats_template'];
			}
		}
		
		// if the user clicks the uninstall button, clean all options and show good-bye message
		if(isset($_POST['uninstall_wpstats'])) 
		{

			delete_option(wpstats_template);
			delete_option(wpstats_version);
			echo '<div class="wrap"><h2>Good Bye!</h2><p>All WP Plugin Stats settings were removed and you can now go to the <a href="plugins.php">plugin menu</a> and deactivate it.</p><h3>Thank you for using WP Plugin Stats '.$wpstats_version.'!</h3><p style="text-align:right"><small>if this happend by accident, <a href="options-general.php?page=wpstatsoptions">click here</a> to reinstall</small></p></div>';
						
		} 
		else // show the menu
		{
			$wpstats_version = get_option(wpstats_version);
			$wpstats_template = get_option(wpstats_template);
			

			// if the wpstats_version is empty or unequal, 
			// write the defaults to the database
			if(trim($wpstats_version) == '') 
			{
				$wpstats_version = WPSTATS_VERSION;
				$wpstats_template =  "Today: <strong>%today%</strong><br />\nYesterday: <strong>%yesterday%</strong><br />\nLast week: <strong>%lastweek%</strong><br />\nTotal: <strong>%total%</strong>";
			}//	*/		
			
			echo '<div class="wrap"><h2>WP Plugin Stats Options</h2><small style="display:block;text-align:right">Version: '.$wpstats_version.'</small><form method="post" action="options-general.php?page=wpstatsoptions">';		
			echo '<input type="hidden" name="update_wpstats" value="true" />';
			
			echo '<table class="optiontable">';
			
	
			echo '<tr valign="top">';
			echo '<th scope="row">Stats template:</th>';
			echo '<td><textarea name="wpstats_template" style="width: 300px; height: 200px;">'.$wpstats_template.'</textarea><br />See readme.txt for details.</td>';
			echo '</tr>';
	
			echo '</table>';
			echo '<p class="submit"><input type="submit" name="Submit" value="Update Options &raquo;" /></p>';
			
			echo '</form>';
			
			
			echo '<h2>Uninstall</h2><form method="post" action="options-general.php?page=wpstatsoptions">';
			echo '<input type="hidden" name="uninstall_wpstats" value="true" />';
			echo '<p class="submit"><input type="submit" name="Submit" value="Clear Settings &raquo;" /></p>';		
			echo '</form>';
			
			
			echo '<p>The plugin assumes all files are installed at:<br />'.$wpstats_path.'/</p></div>';
			
		}
	}

?>